#ifndef TARTRAWSEGMENTOBJECT_H
#define TARTRAWSEGMENTOBJECT_H

#include "TObject.h"
#include <vector>
#include "TArtRawDataObject.h"

class TArtRawSegmentObject : public TObject
{
 public: 
  TArtRawSegmentObject(const unsigned int indev, const unsigned int infp, 
		   const unsigned int indet, const unsigned int inmod){
    device=indev;
    fp=infp;
    detector=indet;
    module=inmod;
  }
  TArtRawSegmentObject();
  virtual ~TArtRawSegmentObject(){ Clear(); }

  virtual void SetSegmentID(const unsigned int indev, 
			    const unsigned int infp, 
			    const unsigned int indet, 
			    const unsigned int inmod){
    device=indev;
    fp=infp;
    detector=indet;
    module=inmod;
  }
  virtual int GetDevice(){return device;}
  virtual int GetFP(){return fp;}
  virtual int GetDetector(){return detector;}
  virtual int GetModule(){return module;}

  virtual void PutData(TArtRawDataObject * indata){
    data_array.push_back(indata);
    return;
  }
  virtual TArtRawDataObject * GetData(int nn){ 
    return data_array[nn];
  }
  virtual void Clear();

  virtual int GetNumData(){return data_array.size();}

 protected:

  // device id, BigRIPS, ZDC, Sharaq
  unsigned int device;
  // focal plane
  unsigned int fp;
  // detector id, such as DALI, PPAC ...
  unsigned int detector;
  // module id, such as CAEN-V490
  unsigned int module;

  // array of data
  std::vector <TArtRawDataObject*> data_array;

  ClassDef(TArtRawSegmentObject,1);

};

#endif
