#ifndef _TARTANALYSISMANAGER_H_
#define _TARTANALYSISMANAGER_H_

#include <TNamed.h>

#include <iostream>
#include <vector>

class TArtRawEventObject;
class TArtLoadMethod;
class TArtAnalysisMethod;

typedef std::vector<TArtLoadMethod*> TArtLoadMethodArray;
typedef std::vector<TArtAnalysisMethod*> TArtAnalysisMethodArray;

class TArtAnalysisManager
{
 public:
  TArtAnalysisManager();
  ~TArtAnalysisManager();

  void AddLoadMethod(TArtLoadMethod* loadmethod);
  void AddAnalysisMethod(TArtAnalysisMethod* independentmethod);

  void DoAll(TArtRawEventObject *event);
  
 private:
  TArtLoadMethodArray fLoadMethodArray;
  TArtAnalysisMethodArray fAnalysisMethodArray;

  ClassDef(TArtAnalysisManager,1);
 };

#endif
