#ifndef _TARTPARAMETERNEBULA_H_
#define _TARTPARAMETERNEBULA_H_

#include "TROOT.h"

#include <iostream>
#include <map>

#include "TArtMap.h"
#include "segidlist.h"

class TXMLNode;
class TArtNEBULAPara;
class TArtRIDFMap;

class TArtParameterNEBULA
{
 public:
  class TArtParameterNEBULAInner
  {
  public:
    TArtParameterNEBULAInner();
    TArtParameterNEBULAInner(Int_t id, TString detname, Int_t fpl,
			     Int_t layer, Int_t sublayer,
			     Double_t tcal, Double_t toff,
			     Double_t qcal, Double_t qped,
			     Int_t ignore);
    ~TArtParameterNEBULAInner();
    
    void SetMap(Int_t tgeo, Int_t tch, Int_t qgeo, Int_t qch)
    {
      fMapADC.SetMap(fFPl,42,qgeo,qch); 
      std::cout << "ADC is mapped to " << fMapADC.GetMapInfo() << " "
		<< fMapADC.GetName() << std::endl;
      fMapTDC.SetMap(fFPl,41,tgeo,tch); 
      std::cout << "TDC is mapped to " << fMapTDC.GetMapInfo() << " "
		<< fMapTDC.GetName() << std::endl;
    }    

    Int_t     fID;
    TString   fDetName;
    Int_t     fFPl;
    Int_t     fLayer;
    Int_t     fSubLayer;
    Double_t  fTCal;
    Double_t  fTOff;
    Double_t  fQCal;
    Double_t  fQPed;
    Int_t     fIgnore;

    TArtRIDFMap fMapTDC;
    TArtRIDFMap fMapADC;
  };

 public:
  TArtParameterNEBULA(char *xmlfile);
  ~TArtParameterNEBULA();

  Bool_t LoadParameter(char *xmlfile);
  void ParseParaList(TXMLNode *node);
  TArtParameterNEBULAInner ParseNEBULAPara(TXMLNode *node);
  const TArtParameterNEBULAInner* Find(const TArtRIDFMap& map);

  std::map<TArtRIDFMap, TArtParameterNEBULAInner> fPMap;
  //  std::map<TArtRIDFMap, TArtParameterNEBULAInner>::iterator fItEnd;
  //  std::map<TArtRIDFMap, TArtParameterNEBULAInner>::iterator fIt;

  ClassDef(TArtParameterNEBULA,1);
};

#endif
