
#include "TArtRawEventObject.h"

#include "TArtAnalysisManager.hh"
#include "TArtLoadMethod.hh"
#include "TArtAnalysisMethod.hh"

#include <TROOT.h>

#include <iostream>
#include <vector>

TArtAnalysisManager::TArtAnalysisManager()
{;}

TArtAnalysisManager::~TArtAnalysisManager()
{
  TArtLoadMethodArray::iterator itlm = fLoadMethodArray.begin();
  while(itlm != fLoadMethodArray.end()){
    delete (*itlm);
    ++itlm;
  }

  TArtAnalysisMethodArray::iterator itam = fAnalysisMethodArray.begin();
  while(itam != fAnalysisMethodArray.end()){
    delete (*itam);
    ++itam;
  }
}

void TArtAnalysisManager::AddLoadMethod(TArtLoadMethod* loadmethod)
{
  std::cout << "AddLoadMethod" << std::endl;

  fLoadMethodArray.push_back(loadmethod);
}

void TArtAnalysisManager::AddAnalysisMethod(TArtAnalysisMethod* independentmethod)
{
  std::cout << "AddAnalysisMethod" << std::endl;

  fAnalysisMethodArray.push_back(independentmethod);
}

void TArtAnalysisManager::DoAll(TArtRawEventObject *event)
{
  TArtLoadMethodArray::iterator itlm = fLoadMethodArray.begin();
  while(itlm != fLoadMethodArray.end()){
    (*(*itlm))(event);
    ++itlm;
  }

  TArtAnalysisMethodArray::iterator itam = fAnalysisMethodArray.begin();
  while(itam != fAnalysisMethodArray.end()){
    (*(*itam))();
    ++itam;
  }
}
