
#include "TArtLoadMethod.hh"
#include "TArtDataNEBULA.hh" 
#include "TArtParameterNEBULA.hh"

#include "TArtRawEventObject.h"
#include "TArtCore.h" 
#include "TArtMap.h"

#include "TROOT.h"

#include <iostream>
#include <map>

TArtLoadMethod::TArtLoadMethod(TArtDataNEBULA *datanebula,
			       const TArtParameterNEBULA *parameternebula)
  : fDataNEBULA(datanebula), fParameterNEBULA(parameternebula)
{;}

TArtLoadMethod::~TArtLoadMethod()
{;}

void TArtLoadMethod::operator()(TArtRawEventObject *event)
{
  std::cout << "LoadMethod()" << std::endl;

  fDataNEBULA->Clear();

  for(int i=0;i<event->GetNumSeg();i++){
    TArtRawSegmentObject *seg = event->GetSegment(i);
    int device   = seg->GetDevice();
    int fpl      = seg->GetFP();
    int detector = seg->GetDetector();
    if(SAMURAI == device)//will be NEBULA??
      for(int j=0;j<seg->GetNumData();j++){
	TArtRawDataObject *d = seg->GetData(j);
	int geo = d->GetGeo(); 
	int ch = d->GetCh(); 
	unsigned int val = d->GetVal();
	TArtRIDFMap map(fpl,detector,geo,ch);
	const TArtParameterNEBULA::TArtParameterNEBULAInner *para
	  = (const_cast<TArtParameterNEBULA*>(fParameterNEBULA))->Find(map);
	if(!para){
	  TArtCore::Info(__FILE__,"Could not find TArtNEBULAPara...: Dev:%d, %s", device, map.GetMapInfo());
	  continue;
	}
	if(para->fIgnore){
	  TArtCore::Info(__FILE__,"Ignore TArtNEBULAPara...: Dev:%d, %s", device, map.GetMapInfo());
	  continue;
	}

	int id = para->fID;
	std::cout << " detector:" << detector << " geo:" << geo << " ch:" << ch << " val:" << val << " id:" << id << std::endl;
	std::map<int, TArtDataNEBULA::TArtDataNEBULAInner>::iterator it
	  = fDataNEBULA->fDataNEBULAInnerMap.find(id);
	if(it == fDataNEBULA->fDataNEBULAInnerMap.end()){
	  TArtDataNEBULA::TArtDataNEBULAInner pla;
	  it = (fDataNEBULA->fDataNEBULAInnerMap.insert
		(std::map<int, TArtDataNEBULA::TArtDataNEBULAInner>::value_type
		 (id, pla))).first;
	}
	TArtDataNEBULA::TArtDataNEBULAInner& pla = it->second;
	if(42 == detector)
	  //	if(NEBULAA == detector)
	  pla.fADC = val;
	if(41 == detector)
	  //	if(NEBULAT == detector)
	  pla.fTDC = val;
      }
  }
}
