// DALI calibration class
// 

#ifndef _TARTCALIBDALI_H_
#define _TARTCALIBDALI_H_

#include <TNamed.h>

class TArtRawEventObject;
class TArtDALIParameters;
class TArtDALI;
class TArtDALIArray;

class TArtCalibDALI  {

 public:

  TArtCalibDALI();
  TArtCalibDALI(TArtDALIParameters * s);
  virtual ~TArtCalibDALI();

  TArtDALIArray    * GetDALI(){return fDALI;}
  TArtDALI         * GetDALI(int i);

  Int_t GetNumDALI();

  void LoadRawData(TArtRawEventObject *);
  void ClearData();
  void ReconstructData();
  void ReconstructData(TArtRawEventObject *);

  bool IsReconstructed(){ return fReconstructed; }

 private:

  bool fReconstructed;

  TArtDALIArray    * fDALI;
  TArtDALIParameters * setup;

  ClassDef(TArtCalibDALI,1);

 };

#endif
